## mysql-workbench 6.3.4+dfsg

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8)
# 2.8 needed because of ExternalProject

project(WORKBENCH)

# Retrieve current Workbench version variables
execute_process(COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/tools/get_wb_version.sh major
                OUTPUT_VARIABLE WB_MAJOR_VERSION)
execute_process(COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/tools/get_wb_version.sh minor
                OUTPUT_VARIABLE WB_MINOR_VERSION)
execute_process(COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/tools/get_wb_version.sh revision
                OUTPUT_VARIABLE WB_RELEASE_VERSION)
execute_process(COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/tools/get_wb_version.sh full_version
                OUTPUT_VARIABLE WB_VERSION)

string(STRIP ${WB_MAJOR_VERSION} WB_MAJOR_VERSION)
string(STRIP ${WB_MINOR_VERSION} WB_MINOR_VERSION)
string(STRIP ${WB_RELEASE_VERSION} WB_RELEASE_VERSION)
string(STRIP ${WB_VERSION} WB_VERSION)


#  About MySQL and CMake
#  http://dev.mysql.com/doc/internals/en/autotools-to-cmake.html
#  http://www.lenzg.net/archives/291-Building-MySQL-Server-with-CMake-on-LinuxUnix.html

#-----------------------------------------------------------------------
# Find packages and other useful checks
#-----------------------------------------------------------------------

# Look for our custom modules in cmake/Modules:
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/build/cmake/Modules/")

find_package(PkgConfig REQUIRED)

find_package(X11)

find_package(GTK2 2.20 REQUIRED gtk gtkmm)
pkg_check_modules(GTHREAD REQUIRED gthread-2.0)
pkg_check_modules(GMODULE REQUIRED gmodule-2.0)
set(GTK2_INCLUDE_DIRS ${GTK2_INCLUDE_DIRS} ${GTHREAD_INCLUDE_DIRS} ${GMODULE_INCLUDE_DIRS})
list(REMOVE_DUPLICATES GTK2_INCLUDE_DIRS)
set(GTK2_LIBRARIES ${GTK2_LIBRARIES} ${GTHREAD_LIBRARIES} ${GMODULE_LIBRARIES})
list(REMOVE_DUPLICATES GTK2_LIBRARIES)

pkg_check_modules(GLIB REQUIRED glib-2.0)

if (USE_BUNDLED_MYSQLDUMP)
  set(USE_BUNDLED_MYSQLDUMP -DHAVE_BUNDLED_MYSQLDUMP=1)
endif ()


find_package(SWIG REQUIRED)
include(${SWIG_USE_FILE})

# All known publicly available versions of Antlr3C are buggy

if (SKIP_BUNDLED_ANTLR)
  find_package(Antlr3C)
endif ()
if (ANTLR3C_FOUND)
  set(ANTLR3C_REQUIRED_VERSION "3.4")
  if (${ANTLR3C_VERSION} VERSION_LESS ${ANTLR3C_REQUIRED_VERSION})
    message("Required antlr3c version ${ANTLR3C_REQUIRED_VERSION} but ${ANTLR3C_VERSION} found, using bundled version")
    unset(ANTLR3C_FOUND)
  endif ()
endif ()

# In Ubuntu 13.04, the built-in check for python fails.. so we have to resort to the check with pkg-config (which doesn't work in many distros)
find_package(PythonLibs 2.6)
if (NOT PYTHONLIBS_FOUND)
    pkg_check_modules(PYTHON REQUIRED python)
endif ()

find_package(MySQL REQUIRED)
if (UNIX)
	set(MYSQL_DEFINITIONS "-DBIG_JOINS=1"  "-fno-strict-aliasing")
endif()

find_package(LibXml2 REQUIRED)

find_package(OpenGL REQUIRED)

find_package(CTemplate)
find_package(MySQLCppConn REQUIRED)
find_package(VSqlite REQUIRED)
find_package(TinyXML REQUIRED)
find_package(GDAL REQUIRED)

if (MYSQLCPPCONN_VERSION_1_1_4)
  add_definitions(-DMYSQLCPPCONN_VERSION_1_1_4)
endif ()

if (MYSQLCPPCONN_VERSION_1_1_5)
  add_definitions(-DMYSQLCPPCONN_VERSION_1_1_5)
endif (MYSQLCPPCONN_VERSION_1_1_5)


if (UNIX)
  option(USE_UNIXODBC "Use unixODBC instead of iODBC" OFF)
  find_package(IODBC)
  find_package(UNIXODBC)

  if (USE_UNIXODBC)
    if (UNIXODBC-NOTFOUND)
      message(FATAL_ERROR "You've selected Unixodbc, but it cannot be found, CMake will exit.")
    else()
		  set(ODBC_LIBRARIES ${UNIXODBC_LIBRARIES})
  		set(ODBC_INCLUDE_DIRS ${UNIXODBC_INCLUDE_DIRS})
	  	set(ODBC_DEFINITIONS ${UNIXODBC_DEFINITIONS})
    endif()
  else()
    if (IODBC_FOUND)
      message("Found iodbc, using it as ODBC library.")
      set(ODBC_LIBRARIES ${IODBC_LIBRARIES})
      set(ODBC_INCLUDE_DIRS ${IODBC_INCLUDE_DIRS})
      set(ODBC_DEFINITIONS ${IODBC_DEFINITIONS})
    elseif (UNIXODBC_FOUND)
      message("Found unixodbc, using it as ODBC library.")
      set(ODBC_LIBRARIES ${UNIXODBC_LIBRARIES})
      set(ODBC_INCLUDE_DIRS ${UNIXODBC_INCLUDE_DIRS})
      set(ODBC_DEFINITIONS ${UNIXODBC_DEFINITIONS})
    else()
      message(FATAL_ERROR "Workbench required iodbc or Unixodbc, none was found, CMake will exit.")
    endif()
  endif(USE_UNIXODBC)

endif(UNIX)


pkg_check_modules(PCRE REQUIRED libpcre libpcrecpp)
pkg_check_modules(CAIRO REQUIRED cairo>=1.5.12)
pkg_check_modules(UUID REQUIRED uuid)
pkg_check_modules(LIBZIP REQUIRED libzip)
if (UNIX)
	pkg_check_modules(GNOME_KEYRING gnome-keyring-1)
	if (GNOME_KEYRING_FOUND)
		set(KEYRING_DEFINITION     "HAVE_GNOME_KEYRING")
	else()
		pkg_check_modules(GNOME_KEYRING gnome-keyring)
		if (GNOME_KEYRING_FOUND)
			set(KEYRING_DEFINITION     "HAVE_OLD_GNOME_KEYRING")
		endif()
	endif()
endif()

if (UNIX)
  include (CheckIncludeFiles)
  CHECK_INCLUDE_FILES ("sys/prctl.h" HAVE_PRCTL)
  if (HAVE_PRCTL)
    add_definitions(-DHAVE_PRCTL_H)
  endif()
endif()

include (CheckFunctionExists)
check_function_exists (strtol HAVE_STRTOL)
check_function_exists (strtoll HAVE_STRTOLL)
check_function_exists (strtold HAVE_STRTOLD)
check_function_exists (strtoull HAVE_STRTOULL)
check_function_exists (strtoimax HAVE_STRTOIMAX)
check_function_exists (strtoumax HAVE_STRTOUMAX)

if (UNIX)
	if (NOT LIB_INSTALL_DIR)
		set(LIB_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/lib")
	endif()
	if (NOT SHARE_INSTALL_PREFIX)
		set(SHARE_INSTALL_PREFIX "${CMAKE_INSTALL_PREFIX}/share")
	endif()
	if (NOT ETC_INSTALL_DIR)
		set(ETC_INSTALL_DIR "/etc")
	endif()
	if (NOT REAL_EXECUTABLE_DIR)
		set(REAL_EXECUTABLE_DIR "${CMAKE_INSTALL_PREFIX}/bin")
	endif()

	set(WB_INSTALL_DIR              "${CMAKE_INSTALL_PREFIX}")
	set(WB_INSTALL_DIR_EXECUTABLE   "${REAL_EXECUTABLE_DIR}")
	set(WB_INSTALL_BIN_DIR          "${CMAKE_INSTALL_PREFIX}/bin")
	set(WB_INSTALL_LIB_DIR          "${LIB_INSTALL_DIR}/mysql-workbench")
	set(WB_PYTHON_MODULES_DIR       "${WB_INSTALL_LIB_DIR}/modules")
	set(WB_INSTALL_SHARED_DIR       "${SHARE_INSTALL_PREFIX}")
	set(WB_INSTALL_ETC_DIR          "${ETC_INSTALL_DIR}")
	set(WB_PACKAGE_SHARED_DIR       "${SHARE_INSTALL_PREFIX}/mysql-workbench")
	set(WB_PACKAGE_PLUGINS_DIR      "${LIB_INSTALL_DIR}/mysql-workbench/plugins")
	set(WB_PYTHON_MODULES_DATA_DIR  "${SHARE_INSTALL_PREFIX}/mysql-workbench/modules/data")
	set(WB_INSTALL_DOC_DIR          "${SHARE_INSTALL_PREFIX}/doc/mysql-workbench")
endif()

include(ExternalProject)

if (NOT ANTLR3C_FOUND)
  message("Using bundled Antlr C runtime")
  #  Use for Antlr3 the one we have in /ext:
  set(ANTLR3C_INCLUDE_DIRS ${PROJECT_SOURCE_DIR}/ext/antlr-runtime ${PROJECT_SOURCE_DIR}/ext/antlr-runtime/include)
  set(ANTLR3C_LIBRARIES "-L${PROJECT_BINARY_DIR}/antlr-wb -lantlr3c_wb")

  ExternalProject_Add(antlr-wb
    SOURCE_DIR ${PROJECT_SOURCE_DIR}/ext/antlr-runtime
    CONFIGURE_COMMAND autoreconf -i -s && ${PROJECT_SOURCE_DIR}/ext/antlr-runtime/configure
        --prefix=${PROJECT_BINARY_DIR}/antlr-wb
        --libdir=${PROJECT_BINARY_DIR}/antlr-wb
	--disable-abiflags
    BUILD_COMMAND make
    BUILD_IN_SOURCE 2
    INSTALL_COMMAND make install
  )

  link_directories(${PROJECT_BINARY_DIR}/antlr-wb)
endif ()

# Uncomment these lines if at any time you want to force the configure and/or build
# of antlr-wb:
#ExternalProject_Add_Step(antlr-wb forceconfigure
#    COMMAND ${CMAKE_COMMAND} -E echo "Force configure of antlr-wb"
#    DEPENDEES update
#    DEPENDERS configure
#    ALWAYS 1
#)
#ExternalProject_Add_Step(antlr-wb forcebuild
#    COMMAND ${CMAKE_COMMAND} -E echo "Force build of antlr-wb"
#    DEPENDEES configure
#    DEPENDERS build
#    ALWAYS 1
#)


#include(CheckCXXCompilerFlag)
#check_cxx_compiler_flag(-Wall  HAS_ALL_WARNS)
#if (HAS_ALL_WARNS)
#	add_definitions(-Wall)
#endif()
#check_cxx_compiler_flag(-Wsign-compare  HAS_SIGN_COMPARE)
#if (HAS_SIGN_COMPARE)
#	add_definitions(-Wsign-compare)
#endif()
add_definitions(-D__STDC_FORMAT_MACROS)

set(BUILD_SHARED_LIBS ON)  # By default all libs will be built as shared libs

# Add some common compiler flags. TODO: Shouldn't this be done checking if whatever compiler
# we use supports each flag to allow for non-gcc compilers in Linux (as above)?
if (CMAKE_COMPILER_IS_GNUCXX)
	set(MY_CXXFLAGS "-Wall -Wextra -Wno-unused-parameter -Wno-deprecated -DTIXML_USE_STL=1")

    set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -Werror -ggdb3 ${MY_CXXFLAGS}")
    set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} ${MY_CXXFLAGS}") 
endif()


#-----------------------------------------------------------------------
# Define some useful variables and options
#-----------------------------------------------------------------------

#set(NCORES 3)  # Use this number of cores when compiling
#if(CMAKE_COMPILER_IS_GNUCXX)
#	set(CMAKE_CXX_FLAGS "${CMAKE_CKK_FLAGS} -j${NCORES}")
#	message(STATUS "CMAKE_CXX_FLAGS = ${CMAKE_CXX_FLAGS}")
#	set(CMAKE_EXE_LINKER_FLAGS_DEBUG "-s")  ## Strip binary
#endif()


set(GRT_LIBRARIES ${PYTHON_LIBRARIES} ${LIBXML2_LIBRARIES})
set(GRT_INCLUDE_DIRS ${PYTHON_INCLUDE_DIRS} ${LIBXML2_INCLUDE_DIR})

configure_file(${PROJECT_SOURCE_DIR}/mysql-workbench.desktop.in mysql-workbench.desktop)

# FIXME: Should this go here? ---v
include_directories(${PROJECT_SOURCE_DIR}/plugins/migration/copytable ${PROJECT_SOURCE_DIR}/library/base)
include_directories(${GTK2_INCLUDE_DIRS})

add_subdirectory(tools)
add_subdirectory(backend)
add_subdirectory(ext)
add_subdirectory(frontend)
add_subdirectory(images)
add_subdirectory(library)
add_subdirectory(modules)
add_subdirectory(plugins)
add_subdirectory(res)
if (IS_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/internal)
  add_subdirectory(internal)
endif()

install(FILES ${CMAKE_BINARY_DIR}/mysql-workbench.desktop DESTINATION ${WB_INSTALL_SHARED_DIR}/applications)

if (EXISTS ${PROJECT_SOURCE_DIR}/COPYING)
    install(FILES README COPYING DESTINATION ${WB_INSTALL_DOC_DIR})
    install(FILES build/mysql-workbench-community.sharedmimeinfo DESTINATION ${WB_INSTALL_SHARED_DIR}/mime/packages RENAME mysql-workbench.xml)
    install(FILES build/mysql-workbench-community.mime DESTINATION ${WB_INSTALL_SHARED_DIR}/mime-info RENAME mysql-workbench.mime)
else ()
    install(FILES README LICENSE.mysql DESTINATION ${WB_INSTALL_DOC_DIR})
    install(FILES build/mysql-workbench-commercial.sharedmimeinfo DESTINATION ${WB_INSTALL_SHARED_DIR}/mime/packages RENAME mysql-workbench.xml)
    install(FILES build/mysql-workbench-commercial.mime DESTINATION ${WB_INSTALL_SHARED_DIR}/mime-info RENAME mysql-workbench.mime)
endif ()

install(FILES build/build_freetds.sh
              samples/models/sakila_full.mwb
        DESTINATION ${WB_PACKAGE_SHARED_DIR}/extras
       )

=== images/ui/CMakeLists.txt ===
set(IMAGE_FILES 
    Apply.png
    Apply_16x16.png
    Close_18x18.png
    Close_16x16.png
    Discard.png
    Discard_16x16.png
    DotBlue.png
    DotDisabled.png
    DotGrey.png
    DotRed.png
    EditorCollapsed.png
    EditorExpanded.png
    firewall-header.png
    First_16x16.png
    Last_16x16.png
    MacWizardBackground.png
    MySQL-WB-about-screen.png
    Refresh_16x16.png
    Refresh_18x18.png
    Refresh_disabled_18x18.png
    arrow_down.png
    arrow_up.png
    audit_log.png
    background.png
    background_stripes_light.png
    background_top_shadow.png
    big_switcher_no.png
    big_switcher_yes.png
    busy_sidebar.png
    busy_sidebar_mac.png
    change_alert_create.png
    change_alert_drop.png
    change_alert_thin.png
    change_backward.png
    change_forward.png
    change_ignore.png
    change_nothing.png
    check.png
    collapsing_panel_bg.png
    collapsing_panel_grid_bg.png
    collapsing_panel_grid_details.png
    collapsing_panel_grid_details2.png
    collapsing_panel_grid_large_icons.png
    collapsing_panel_grid_large_icons2.png
    collapsing_panel_grid_small_icons.png
    collapsing_panel_grid_small_icons2.png
    collapsing_panel_header_bg.png
    collapsing_panel_header_bg_flat.png
    collapsing_panel_header_shadow.png
    collapsing_panel_header_tab_add.png
    collapsing_panel_header_tab_add2.png
    collapsing_panel_header_tab_del.png
    collapsing_panel_header_tab_del2.png
    collapsing_panel_header_tab_left.png
    collapsing_panel_header_tab_left_flat.png
    collapsing_panel_header_tab_middle.png
    collapsing_panel_header_tab_middle_flat.png
    collapsing_panel_header_tab_right.png
    collapsing_panel_header_tab_right_flat.png
    collapsing_panel_header_tab_separator.png
    collapsing_panel_header_tab_separator_flat.png
    collapsing_panel_minus.png
    collapsing_panel_minus_flat.png
    collapsing_panel_plus.png
    collapsing_panel_plus_flat.png
    collapsing_panel_tab_left.png
    collapsing_panel_tab_middle.png
    collapsing_panel_tab_right.png
    dialog_input.png
    edit.png
    field_overlay_blob.png
    field_overlay_null.png
    header_bar_blue.png
    header_bar_gray.png
    header_bar_orange.png
    item_overlay_add.png
    item_overlay_delete.png
    message_confirm.png
    message_edit.png
    message_error.png
    message_warning.png
    message_wb_bug.png
    message_wb_lock.png
    message_wb_wait.png
    navigator_zoom_in.png
    navigator_zoom_out.png
    note.128x128.png
    options-horizontal-separator.png
    refresh_sidebar.png
    refresh_sidebar_mac.png
    sakila.png
    search_clear.png
    search_doc_action.png
    search_icon.png
    search_sidebar.png
    section_expanded.png
    section_unexpandable.png
    section_unexpanded.png
    separator-dots.png
    separator_vertical.png
    show_eof.png
    show_whitespace.png
    small_toolbar_bg.png
    statusbar_output.png
    statusbar_separator.png
    statusbar_shell.png
    switcher_bottom_off_win8.png
    switcher_bottom_on_win8.png
    switcher_left_off_win8.png
    switcher_left_on_win8.png
    switcher_right_off_win8.png
    switcher_right_on_win8.png
    tab.diagram.16x16.png
    tab.overview.home.16x16.png
    tab.overview.physical.16x16.png
    tab.sqlquery.16x16.png
    task_checked.png
    task_checked_mac.png
    task_disabled.png
    task_disabled_mac.png
    task_error.png
    task_error_mac.png
    task_executing.png
    task_executing_mac.png
    task_unchecked.png
    task_unchecked_mac.png
    task_warning.png
    task_warning_mac.png
    tree_collapsed.png
    tree_expanded.png
    uncheck.png
    unknown.png
    wait_panel_cancel_button.png
    wb-wizard-vista-bg.png
    wb_lock.png
    zoom_in.png
    zoom_out.png
    zoom_reset.png
    editor_breakpoint_hit.xpm
    editor_breakpoint.xpm
    editor_current_pos.xpm
    editor_error.xpm
    editor_statement.xpm
)

if (UNIX)
    set(IMAGE_FILES ${IMAGE_FILES}
            linux/switcher_bottom_off.png
            linux/switcher_bottom_on.png
            linux/switcher_left_off.png
            linux/switcher_left_on.png
            linux/switcher_right_off.png
            linux/switcher_right_on.png
       )
elseif (APPLE)
    set(IMAGE_FILES ${IMAGE_FILES}
            switcher_bottom_off.png
            switcher_bottom_on.png
            switcher_left_off.png
            switcher_left_on.png
            switcher_right_off.png
            switcher_right_on.png
            tab_00.png
            tab_01.png
            tab_02.png
            tab_03.png
            tab_05.png
            tab_06.png
            tab_07.png
            tab_08.png
            tab_09.png
            tab_10.png
            tab_11.png
            tab_icon_db.Routine.png
            tab_icon_db.query.QueryBuffer.png
            tab_icon_db.Schema.png
            tab_icon_db.Table.png
            tab_icon_db.View.png
       )
endif ()

install(FILES ${IMAGE_FILES} DESTINATION ${WB_PACKAGE_SHARED_DIR}/images)

=== modules/wb.model/CMakeLists.txt ===
if (CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
	add_definitions(-DSCI_LEXER -DSCI_NAMESPACE)
endif()

set(TEXT_BASIC_FILES
    res/wb_model_reporting/Text_Basic.tpl/preview_basic.png
    res/wb_model_reporting/Text_Basic.tpl/report.txt.tpl
    res/wb_model_reporting/Text_Basic.tpl/info.xml
)
install(FILES ${TEXT_BASIC_FILES} DESTINATION ${WB_PACKAGE_SHARED_DIR}/modules/data/wb_model_reporting/Text_Basic.tpl)

set(HTML_BASIC_FRAME_FILES
    res/wb_model_reporting/HTML_Basic_Frames.tpl/overview.html.tpl
    res/wb_model_reporting/HTML_Basic_Frames.tpl/basic.css.tpl
    res/wb_model_reporting/HTML_Basic_Frames.tpl/preview_basic.png
    res/wb_model_reporting/HTML_Basic_Frames.tpl/restrained.css.tpl
    res/wb_model_reporting/HTML_Basic_Frames.tpl/table_details.html.tpl
    res/wb_model_reporting/HTML_Basic_Frames.tpl/index.html.tpl
    res/wb_model_reporting/HTML_Basic_Frames.tpl/info.xml
)
install(FILES ${HTML_BASIC_FRAME_FILES} DESTINATION ${WB_PACKAGE_SHARED_DIR}/modules/data/wb_model_reporting/HTML_Basic_Frames.tpl)

set(HTML_BASIC_SINGLE_FILES
    res/wb_model_reporting/HTML_Basic_Single_Page.tpl/basic.css.tpl
    res/wb_model_reporting/HTML_Basic_Single_Page.tpl/index.html.tpl
    res/wb_model_reporting/HTML_Basic_Single_Page.tpl/info.xml
)
install(FILES ${HTML_BASIC_SINGLE_FILES} DESTINATION ${WB_PACKAGE_SHARED_DIR}/modules/data/wb_model_reporting/HTML_Basic_Single_Page.tpl)

set(HTML_DETAILED_FRAMES_FILES
    res/wb_model_reporting/HTML_Detailed_Frames.tpl/basic.css.tpl
    res/wb_model_reporting/HTML_Detailed_Frames.tpl/coated.css.tpl
    res/wb_model_reporting/HTML_Detailed_Frames.tpl/index.html.tpl
    res/wb_model_reporting/HTML_Detailed_Frames.tpl/info.xml
    res/wb_model_reporting/HTML_Detailed_Frames.tpl/overview.html.tpl
    res/wb_model_reporting/HTML_Detailed_Frames.tpl/overview_list.html.tpl
    res/wb_model_reporting/HTML_Detailed_Frames.tpl/routine_details.html.tpl
    res/wb_model_reporting/HTML_Detailed_Frames.tpl/table_details.html.tpl
    res/wb_model_reporting/HTML_Detailed_Frames.tpl/table_details_list.html.tpl
    res/wb_model_reporting/HTML_Detailed_Frames.tpl/table_element_details.html.tpl
    res/wb_model_reporting/HTML_Detailed_Frames.tpl/top.html.tpl
    res/wb_model_reporting/HTML_Detailed_Frames.tpl/view_details.html.tpl
)
install(FILES ${HTML_DETAILED_FRAMES_FILES} DESTINATION ${WB_PACKAGE_SHARED_DIR}/modules/data/wb_model_reporting/HTML_Detailed_Frames.tpl)

set(HTML_DETAILED_FRAMES_IMAGES_FILES
    res/wb_model_reporting/HTML_Detailed_Frames.tpl/images/logo.png
    res/wb_model_reporting/HTML_Detailed_Frames.tpl/images/back.png
    res/wb_model_reporting/HTML_Detailed_Frames.tpl/images/title-background.png
    res/wb_model_reporting/HTML_Detailed_Frames.tpl/images/next.png
    res/wb_model_reporting/HTML_Detailed_Frames.tpl/images/preview_coated.png
    res/wb_model_reporting/HTML_Detailed_Frames.tpl/images/preview_main.png
)
install(FILES ${HTML_DETAILED_FRAMES_IMAGES_FILES} DESTINATION ${WB_PACKAGE_SHARED_DIR}/modules/data/wb_model_reporting/HTML_Detailed_Frames.tpl/images)

include_directories(.
    ${PROJECT_SOURCE_DIR}/generated
    ${PROJECT_SOURCE_DIR}/backend/wbpublic
    ${PROJECT_SOURCE_DIR}/modules
    ${PROJECT_SOURCE_DIR}/library/grt/src 
    ${PROJECT_SOURCE_DIR}/library/base
    ${PROJECT_SOURCE_DIR}/modules/interfaces
    ${PROJECT_SOURCE_DIR}/library/grt/src/diff
    ${PROJECT_SOURCE_DIR}/library/sql-parser/include
    ${PROJECT_SOURCE_DIR}/library/sql-parser/source
    ${PROJECT_SOURCE_DIR}/library/sql-parser/source/linux
    ${PROJECT_SOURCE_DIR}/ext/scintilla/include
    ${PROJECT_SOURCE_DIR}/ext/scintilla/src
    ${PROJECT_SOURCE_DIR}/ext/scintilla/lexlib
    ${PROJECT_SOURCE_DIR}/ext
    ${PROJECT_SOURCE_DIR}/library/forms
    ${PROJECT_SOURCE_DIR}/modules/db.mysql.sqlide/src
    ${GTK2_INCLUDE_DIRS}
    ${PCRE_INCLUDE_DIRS}
    ${MYSQL_INCLUDE_DIRS}
    ${CTEMPLATE_INCLUDE_DIRS}
    ${GRT_INCLUDE_DIRS}
    ${PROJECT_SOURCE_DIR}
)

add_library(wb.model.grt
    src/reporting.cpp 
    src/wb_model.cpp
)

target_link_libraries(wb.model.grt grt ${GRT_LIBRARIES} ${GTK2_LIBRARIES} ${PCRE_LIBRARIES} ${MYSQL_LIBRARIES} ${CTEMPLATE_LIBRARIES})

set_target_properties(wb.model.grt
                      PROPERTIES PREFIX    ""
                                 VERSION   ${WB_VERSION}
                                 SOVERSION ${WB_VERSION})

install(TARGETS wb.model.grt DESTINATION ${WB_INSTALL_LIB_DIR}/modules)

=== plugins/migration/CMakeLists.txt ===
include_directories(
    ${ODBC_INCLUDE_DIRS} 
    ${PYTHON_INCLUDE_DIRS} 
    ${MYSQL_INCLUDE_DIRS} 
    ${PROJECT_SOURCE_DIR}/backend/wbprivate
)

add_definitions(${ODBC_DEFINITIONS})

if (UNIX)
  configure_file(wbcopytables.in wbcopytables)
  install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/wbcopytables DESTINATION ${WB_INSTALL_BIN_DIR})
  
  add_executable(wbcopytables-bin
      copytable/copytable.cpp
      copytable/python_copy_data_source.cpp
      copytable/main.cpp
      copytable/converter.cpp
  )
  
  target_link_libraries(wbcopytables-bin wbbase ${MYSQL_LIBRARIES} ${ODBC_LIBRARIES} ${PCRE_LIBRARIES} ${PYTHON_LIBRARIES})
  
  install(TARGETS wbcopytables-bin DESTINATION ${WB_INSTALL_DIR_EXECUTABLE})
else()
  add_executable(wbcopytables
      copytable/copytable.cpp
      copytable/python_copy_data_source.cpp
      copytable/main.cpp
      copytable/converter.cpp
  )
  
  target_link_libraries(wbcopytables wbbase ${MYSQL_LIBRARIES} ${ODBC_LIBRARIES} ${PCRE_LIBRARIES} ${PYTHON_LIBRARIES})
  
  install(TARGETS wbcopytables DESTINATION ${WB_INSTALL_BIN_DIR})
endif()

set(PY_FILES 
    frontend/migration_project_management.py
    frontend/migration_schema_selection.py
    frontend/migration_overview.py
    frontend/datatype_mapping_editor.py
    frontend/migration_schema_mappings.py
    frontend/migration_schema_creation.py
    frontend/migration_source_selection.py
    frontend/migration_object_migration.py
    frontend/migration_object_selection.py
    frontend/migration_data_transfer.py
    frontend/migration_ui_style.py
    frontend/migration_toolbars.py
    frontend/migration_main.py
    frontend/migration_summary.py
    frontend/migration_object_editing.py
    frontend/migration_bulk_copy_data.py
    backend/migration.py
    backend/DataMigrator.py
    dbcopy/db_copy_grt.py
    dbcopy/db_copy_main.py
    dbcopy/db_copy_overview.py
    dbcopy/db_copy_source_target.py
    dbcopy/db_copy_schema_selection.py
    dbcopy/db_copy_progress.py
    dbcopy/db_copy_report.py
    migration_grt.py
)

install(FILES ${PY_FILES} DESTINATION ${WB_PYTHON_MODULES_DIR})

=== plugins/wb.admin/CMakeLists.txt ===
set(PY_FILES 
    backend/opts.py
    backend/wb_admin_config_file_be.py
    backend/wb_admin_control.py
    backend/wb_admin_security_be.py
    backend/wb_admin_ssh.py
    backend/wb_admin_user_privileges.py
    backend/wb_admin_variable_list.py
    backend/wb_common.py
    backend/wb_log_reader.py
    backend/wb_server_control.py
    backend/wb_server_management.py
    backend/wba_monitor_be.py
    backend/wb_admin_perfschema_instrumentation_be.py
    frontend/wb_admin_config_file_ui.py
    frontend/wb_admin_configuration_startup.py
    frontend/wb_admin_connections.py
    frontend/wb_admin_export.py
    frontend/wb_admin_export_options.py
    frontend/wb_admin_grt.py
    frontend/wb_admin_logs.py
    frontend/wb_admin_main.py
    frontend/wb_admin_monitor.py
    frontend/wb_admin_security.py
    frontend/wb_admin_server_status.py
    frontend/wb_admin_ui_profile.py
    frontend/wb_admin_utils.py
    frontend/wb_admin_variables.py
    frontend/wb_execute_window.py
    frontend/wba_ssh_ui.py
    frontend/wb_admin_perfschema.py
    frontend/wb_admin_perfschema_instrumentation.py
    frontend/wb_admin_perfschema_reports.py
    frontend/wb_admin_performance_dashboard.py
)

if (IS_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/internal)
    set(PY_WBA_MEB_FILES 
        internal/wba_meb/__init__.py
        internal/wba_meb/wb_admin_meb.py
        internal/wba_meb/wb_admin_meb_common.py
        internal/wba_meb/wb_admin_meb_config.py
        internal/wba_meb/wb_admin_meb_editor.py
        internal/wba_meb/wb_admin_meb_management.py
        internal/wba_meb/wb_admin_meb_overview.py
        internal/wba_meb/wb_admin_meb_restore.py
        internal/wba_meb/wb_admin_meb_syshelpers.py
    )
    install(FILES ${PY_WBA_MEB_FILES} DESTINATION ${WB_PYTHON_MODULES_DIR}/wba_meb)
    
    set(PY_WBA_AUDIT_FILES 
        internal/wba_audit/__init__.py
        internal/wba_audit/wb_admin_audit_browser.py
        internal/wba_audit/wb_admin_audit_inspector.py
        internal/wba_audit/wb_admin_audit_log_parser.py
    )
    install(FILES ${PY_WBA_AUDIT_FILES} DESTINATION ${WB_PYTHON_MODULES_DIR}/wba_audit)
    
    set(PY_WBA_FIREWALL_FILES 
        internal/wba_firewall/__init__.py
        internal/wba_firewall/wb_admin_firewall.py
    )
    install(FILES ${PY_WBA_FIREWALL_FILES} DESTINATION ${WB_PYTHON_MODULES_DIR}/wba_firewall)
endif ()

install(FILES ${PY_FILES} DESTINATION ${WB_PYTHON_MODULES_DIR})

=== res/scripts/CMakeLists.txt ===
set(LIBRARY_FILES 
    python/wb.py
    python/db_utils.py
    python/grt_python_debugger.py
)
install(FILES ${LIBRARY_FILES} DESTINATION ${WB_PACKAGE_SHARED_DIR}/libraries)


set(SHELL_SNIPPETS_FILES
    snippets/shell_snippets.py.txt
)
install(FILES ${SHELL_SNIPPETS_FILES} DESTINATION ${WB_PACKAGE_SHARED_DIR})


set(VBSDATA_FILES
    shell/mysql_system_status.vbs
    shell/mysql_system_status_rmt.vbs
    python/mysqlwbmeb.py
)
install(FILES ${VBSDATA_FILES} DESTINATION ${WB_PACKAGE_SHARED_DIR})


set(TEMPLATE_FILES
    script_templates/eer_model_object_grt.py.txt
    script_templates/eer_model_utility_grt.py.txt
    script_templates/generic_grt.py.txt
    script_templates/sql_editor_catalog_grt.py.txt
    script_templates/sql_editor_filter_grt.py.txt
    script_templates/sql_editor_resultset_grt.py.txt
    script_templates/sql_editor_utility_grt.py.txt
)

install(FILES ${TEMPLATE_FILES} DESTINATION ${WB_PACKAGE_SHARED_DIR}/script_templates)

# Do not edit WBSYS_FILES manualy. The containing files are updated 
# by res/scripts/update_wbsys.py script
# SYS_BEGIN

set(SYS_FILES
    sys/after_setup.sql
    sys/before_setup.sql
    sys/sys_56.sql
    sys/sys_57.sql
    sys/sys_reports.js
    sys/generate_sql_file.sh
)

install(FILES ${SYS_FILES} DESTINATION ${WB_PACKAGE_SHARED_DIR}/sys)

set(SYS_FUNCTIONS_FILES
    sys/functions/extract_schema_from_file_name.sql
    sys/functions/extract_table_from_file_name.sql
    sys/functions/format_bytes.sql
    sys/functions/format_path.sql
    sys/functions/format_statement.sql
    sys/functions/format_time.sql
    sys/functions/ps_is_account_enabled.sql
    sys/functions/ps_is_instrument_default_enabled.sql
    sys/functions/ps_is_instrument_default_timed.sql
    sys/functions/ps_is_account_enabled_57.sql
	sys/functions/ps_is_consumer_enabled.sql
	sys/functions/ps_is_thread_instrumented.sql
    sys/functions/ps_thread_id.sql
    sys/functions/ps_thread_stack.sql
    sys/functions/sys_get_config.sql
)

install(FILES ${SYS_FUNCTIONS_FILES} DESTINATION ${WB_PACKAGE_SHARED_DIR}/sys/functions)

set(SYS_VIEWS_P_S_FILES
    sys/views/p_s/host_summary.sql
    sys/views/p_s/host_summary_57.sql
    sys/views/p_s/host_summary_by_file_io.sql
    sys/views/p_s/host_summary_by_file_io_type.sql
    sys/views/p_s/host_summary_by_stages.sql
    sys/views/p_s/host_summary_by_statement_latency.sql
    sys/views/p_s/host_summary_by_statement_type.sql
    sys/views/p_s/io_by_thread_by_latency.sql
    sys/views/p_s/io_global_by_file_by_bytes.sql
    sys/views/p_s/io_global_by_file_by_latency.sql
    sys/views/p_s/io_global_by_wait_by_bytes.sql
    sys/views/p_s/io_global_by_wait_by_latency.sql
    sys/views/p_s/latest_file_io.sql
    sys/views/p_s/memory_by_user.sql
    sys/views/p_s/memory_global_by_current_allocated.sql
    sys/views/p_s/memory_global_total.sql
    sys/views/p_s/processlist.sql
    sys/views/p_s/processlist_57.sql
    sys/views/p_s/ps_check_lost_instrumentation.sql
    sys/views/p_s/schema_index_statistics.sql
    sys/views/p_s/schema_table_statistics.sql
    sys/views/p_s/schema_table_statistics_with_buffer.sql
    sys/views/p_s/schema_tables_with_full_table_scans.sql
    sys/views/p_s/schema_unused_indexes.sql
    sys/views/p_s/statement_analysis.sql
    sys/views/p_s/statements_with_errors_or_warnings.sql
    sys/views/p_s/statements_with_full_table_scans.sql
    sys/views/p_s/statements_with_runtimes_in_95th_percentile.sql
    sys/views/p_s/statements_with_sorting.sql
    sys/views/p_s/statements_with_temp_tables.sql
    sys/views/p_s/user_summary.sql
    sys/views/p_s/user_summary_57.sql
    sys/views/p_s/user_summary_by_file_io.sql
    sys/views/p_s/user_summary_by_file_io_type.sql
    sys/views/p_s/user_summary_by_stages.sql
    sys/views/p_s/user_summary_by_statement_latency.sql
    sys/views/p_s/user_summary_by_statement_type.sql
    sys/views/p_s/wait_classes_global_by_avg_latency.sql
    sys/views/p_s/wait_classes_global_by_latency.sql
    sys/views/p_s/waits_by_host_by_latency.sql
    sys/views/p_s/waits_by_user_by_latency.sql
    sys/views/p_s/waits_global_by_latency.sql
    sys/views/p_s/memory_by_host_by_current_bytes.sql
	sys/views/p_s/memory_by_thread_by_current_bytes.sql
	sys/views/p_s/memory_by_user_by_current_bytes.sql
	sys/views/p_s/memory_global_by_current_bytes.sql
	sys/views/p_s/x_host_summary.sql
	sys/views/p_s/x_host_summary_57.sql
	sys/views/p_s/x_host_summary_by_file_io.sql
	sys/views/p_s/x_host_summary_by_file_io_type.sql
	sys/views/p_s/x_host_summary_by_stages.sql
	sys/views/p_s/x_host_summary_by_statement_latency.sql
	sys/views/p_s/x_host_summary_by_statement_type.sql
	sys/views/p_s/x_io_by_thread_by_latency.sql
	sys/views/p_s/x_io_global_by_file_by_bytes.sql
	sys/views/p_s/x_io_global_by_file_by_latency.sql
	sys/views/p_s/x_io_global_by_wait_by_bytes.sql
	sys/views/p_s/x_io_global_by_wait_by_latency.sql
	sys/views/p_s/x_latest_file_io.sql
	sys/views/p_s/x_memory_by_host_by_current_bytes.sql
	sys/views/p_s/x_memory_by_thread_by_current_bytes.sql
	sys/views/p_s/x_memory_by_user_by_current_bytes.sql
	sys/views/p_s/x_memory_global_by_current_bytes.sql
	sys/views/p_s/x_memory_global_total.sql
	sys/views/p_s/x_processlist.sql
	sys/views/p_s/x_processlist_57.sql
	sys/views/p_s/x_ps_digest_95th_percentile_by_avg_us.sql
	sys/views/p_s/x_ps_digest_avg_latency_distribution.sql
	sys/views/p_s/x_ps_schema_table_statistics_io.sql
	sys/views/p_s/x_schema_index_statistics.sql
	sys/views/p_s/x_schema_table_statistics.sql
	sys/views/p_s/x_schema_table_statistics_with_buffer.sql
	sys/views/p_s/x_schema_tables_with_full_table_scans.sql
	sys/views/p_s/x_statement_analysis.sql
	sys/views/p_s/x_statements_with_errors_or_warnings.sql
	sys/views/p_s/x_statements_with_full_table_scans.sql
	sys/views/p_s/x_statements_with_runtimes_in_95th_percentile.sql
	sys/views/p_s/x_statements_with_sorting.sql
	sys/views/p_s/x_statements_with_temp_tables.sql
	sys/views/p_s/x_user_summary.sql
	sys/views/p_s/x_user_summary_57.sql
	sys/views/p_s/x_user_summary_by_file_io.sql
	sys/views/p_s/x_user_summary_by_file_io_type.sql
	sys/views/p_s/x_user_summary_by_stages.sql
	sys/views/p_s/x_user_summary_by_statement_latency.sql
	sys/views/p_s/x_user_summary_by_statement_type.sql
	sys/views/p_s/x_wait_classes_global_by_avg_latency.sql
	sys/views/p_s/x_wait_classes_global_by_latency.sql
	sys/views/p_s/x_waits_by_host_by_latency.sql
	sys/views/p_s/x_waits_by_user_by_latency.sql
	sys/views/p_s/x_waits_global_by_latency.sql
)

install(FILES ${SYS_VIEWS_P_S_FILES} DESTINATION ${WB_PACKAGE_SHARED_DIR}/sys/views/p_s)

set(SYS_PROCEDURES_FILES
    sys/procedures/create_synonym_db.sql
    sys/procedures/ps_setup_disable_background_threads.sql
    sys/procedures/ps_setup_disable_consumers.sql
    sys/procedures/ps_setup_disable_instrument.sql
    sys/procedures/ps_setup_disable_thread.sql
    sys/procedures/ps_setup_enable_background_threads.sql
    sys/procedures/ps_setup_enable_consumers.sql
    sys/procedures/ps_setup_enable_instrument.sql
    sys/procedures/ps_setup_enable_thread.sql
    sys/procedures/ps_setup_reload_saved.sql
    sys/procedures/ps_setup_reset_to_default.sql
    sys/procedures/ps_setup_reset_to_default_57.sql
    sys/procedures/ps_setup_save.sql
    sys/procedures/ps_setup_show_disabled.sql
    sys/procedures/ps_setup_show_disabled_consumers.sql
    sys/procedures/ps_setup_show_disabled_instruments.sql
    sys/procedures/ps_setup_show_enabled.sql
    sys/procedures/ps_setup_show_enabled_consumers.sql
    sys/procedures/ps_setup_show_enabled_instruments.sql
    sys/procedures/ps_statement_avg_latency_histogram.sql
    sys/procedures/ps_trace_statement_digest.sql
    sys/procedures/ps_trace_thread.sql
    sys/procedures/ps_truncate_all_tables.sql
    sys/procedures/ps_setup_disable_consumer.sql
	sys/procedures/ps_setup_enable_consumer.sql
	sys/procedures/ps_setup_reset_to_default_57_after.sql
	sys/procedures/ps_setup_reset_to_default_57_before.sql
)

install(FILES ${SYS_PROCEDURES_FILES} DESTINATION ${WB_PACKAGE_SHARED_DIR}/sys/procedures)

set(SYS_VIEWS_I_S_FILES
    sys/views/i_s/innodb_buffer_stats_by_schema.sql
    sys/views/i_s/innodb_buffer_stats_by_table.sql
    sys/views/i_s/schema_object_overview.sql
    sys/views/i_s/innodb_lock_waits.sql
	sys/views/i_s/x_innodb_buffer_stats_by_schema.sql
	sys/views/i_s/x_innodb_buffer_stats_by_table.sql
	sys/views/i_s/x_innodb_lock_waits.sql
)

install(FILES ${SYS_VIEWS_I_S_FILES} DESTINATION ${WB_PACKAGE_SHARED_DIR}/sys/views/i_s)

set(SYS_TABLES_FILES
	sys/tables/sys_config.sql
	sys/tables/sys_config_data.sql
)

install(FILES ${SYS_TABLES_FILES} DESTINATION ${WB_PACKAGE_SHARED_DIR}/sys/tables)

set(SYS_TRIGGERS_FILES
	sys/triggers/sys_config_insert_set_user.sql
	sys/triggers/sys_config_update_set_user.sql
)

install(FILES ${SYS_TRIGGERS_FILES} DESTINATION ${WB_PACKAGE_SHARED_DIR}/sys/triggers)
# SYS_END


set(FIREWALL_LINUX_SERVER_FILES
    firewall/linux/install.sql
    firewall/linux/uninstall.sql
    firewall/linux/enable.sql
    firewall/linux/disable.sql
)

set(FIREWALL_WINDOWS_SERVER_FILES
    firewall/linux/install.sql
    firewall/linux/uninstall.sql
    firewall/linux/enable.sql
    firewall/linux/disable.sql
)

install(FILES ${FIREWALL_LINUX_SERVER_FILES} DESTINATION ${WB_PACKAGE_SHARED_DIR}/firewall/linux)
install(FILES ${FIREWALL_WINDOWS_SERVER_FILES} DESTINATION ${WB_PACKAGE_SHARED_DIR}/firewall/windows)

=== frontend/linux/workbench/CMakeLists.txt ===
if (CMAKE_COMPILER_IS_GNUCXX)
	add_definitions(-rdynamic)
endif()

set(WORKBENCH_DATA_FILES
    res/wb.glade
    res/model_view.glade
    res/diagram_view.glade
    res/find.glade
    res/diagram_size_form.glade
    res/input_dialog.glade
    workbench.rc
)
install(FILES ${WORKBENCH_DATA_FILES} DESTINATION ${WB_PACKAGE_SHARED_DIR})

set(libdir          ${LIB_INSTALL_DIR})
set(utilities_cmd   "")
configure_file(mysql-workbench.in mysql-workbench)
install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/mysql-workbench DESTINATION ${WB_INSTALL_BIN_DIR})

include_directories(.
    ${PROJECT_SOURCE_DIR}
    ${PROJECT_SOURCE_DIR}/library/grt/src
    ${PROJECT_SOURCE_DIR}/library/base
    ${PROJECT_SOURCE_DIR}/backend
    ${PROJECT_SOURCE_DIR}/generated
    ${PROJECT_SOURCE_DIR}/backend/wbprivate/workbench
    ${PROJECT_SOURCE_DIR}/frontend/linux/linux_utilities
    ${PROJECT_SOURCE_DIR}/backend/wbpublic
    ${PROJECT_SOURCE_DIR}/backend/wbpublic/grt
    ${PROJECT_SOURCE_DIR}/backend/wbprivate
    ${PROJECT_SOURCE_DIR}/frontend/linux/
    ${PROJECT_SOURCE_DIR}/library/forms
    ${PROJECT_SOURCE_DIR}/library/cdbc/src
    ${PROJECT_SOURCE_DIR}/library/forms/gtk
    ${PROJECT_SOURCE_DIR}/library/forms/gtk/src
    ${PROJECT_SOURCE_DIR}/generated/grti
    ${PROJECT_SOURCE_DIR}/modules/wb.model/src
    ${PROJECT_SOURCE_DIR}/modules/interfaces
    ${PROJECT_SOURCE_DIR}/ext
    ${PROJECT_SOURCE_DIR}/modules
    ${PROJECT_SOURCE_DIR}/ext/scintilla/include
    ${PROJECT_SOURCE_DIR}/library/forms/mforms
    ${PROJECT_SOURCE_DIR}/library/mysql.canvas/src
    ${PROJECT_SOURCE_DIR}/library/mysql.parser
    ${GTK2_INCLUDE_DIRS}
    ${CAIRO_INCLUDE_DIRS}
    ${LIBZIP_INCLUDE_DIRS}
    ${MYSQLCPPCONN_INCLUDE_DIRS}
    ${GRT_INCLUDE_DIRS}
    ${GNOME_KEYRING_INCLUDE_DIRS}
)

#link_directories(${PROJECT_BINARY_DIR}/mysqlcppconnector/lib ${PROJECT_BINARY_DIR}/antlr-wb)
SET(CMAKE_INSTALL_RPATH "${WB_INSTALL_LIB_DIR}")
add_executable(mysql-workbench-bin
    main.cpp
    program.cpp
    main_form.cpp
    overview_panel.cpp
    model_panel.cpp
    model_diagram_panel.cpp
    properties_tree.cpp
    navigator_box.cpp
    info_box.cpp
    documentation_box.cpp
    diagram_size_form.cpp
    validation_panel.cpp
    sqlide_form.cpp
    sqlide_output_view.cpp
    sqlide_main.cpp
    ../../common/new_server_instance_wizard.cpp
    ../../common/grt_code_editor.cpp
    ../../common/server_instance_editor.cpp
    ../../common/grt_python_debugger.cpp
    ../../common/advanced_sidebar.cpp
    ../../common/snippet_popover.cpp
    ../../common/grt_plugin_wizard.cpp
)

if (KEYRING_DEFINITION)
	set_target_properties(mysql-workbench-bin PROPERTIES
		COMPILE_DEFINITIONS "${KEYRING_DEFINITION}"
	)
endif()

target_link_libraries(mysql-workbench-bin
    mforms
    linux_utilities
    sqlide
    wbprivate
    wbpublic
    wbbase
    grt
    cdbc
    wbscintilla
    mdcanvasgtk
    mdcanvas
    mysqlparser
    ${MYSQLCPPCONN_LIBRARIES}
    ${CTEMPLATE_LIBRARIES}
    ${X11_LIBRARIES}
    ${GTK2_LIBRARIES}
    ${SIGC++_LIBRARIES}
    ${GRT_LIBRARIES}
    ${PCRE_LIBRARIES}
    ${CAIRO_LIBRARIES}
    ${LIBZIP_LIBRARIES}
    ${MYSQL_LIBRARIES}
    ${SQLITE3_LIBRARIES}
    ${GNOME_KEYRING_LIBRARIES}
)

install(TARGETS mysql-workbench-bin DESTINATION ${WB_INSTALL_DIR_EXECUTABLE})

=== debian/changelog ===
mysql-workbench (6.3.4+dfsg-1build2) wily; urgency=medium

  * No-change rebuild against libgdal1i

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 23 Aug 2015 01:20:45 +0000

mysql-workbench (6.3.4+dfsg-1build1) wily; urgency=medium

  * No-change rebuild against libtinyxml2.6.2v5

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 04 Aug 2015 20:42:47 +0000

mysql-workbench (6.3.4+dfsg-1) unstable; urgency=low

  * New upstream release [June 2015] (Closes: #784729).
  * Upstream tarball signature verification.
  * get-orig-source: reproducible sort.

 -- Dmitry Smirnov <onlyjob@debian.org>  Wed, 17 Jun 2015 21:34:03 +1000

mysql-workbench (6.3.3+dfsg-1) unstable; urgency=low

  * New upstream release [April 2015].

 -- Dmitry Smirnov <onlyjob@debian.org>  Mon, 27 Apr 2015 15:15:03 +1000

=== debian/control ===
Source: mysql-workbench
Section: database
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Dmitry Smirnov <onlyjob@debian.org>
Uploaders: Mateusz Kijowski <mateusz.kijowski@gmail.com>
Build-Depends: debhelper (>= 9), dh-autoreconf, cmake, perl, imagemagick
 ,autoconf ,automake ,libtool
 ,bison ,flex ,swig
 ,doxygen
 ,gettext
# ,libantlr3c-dev
 ,libboost-dev
 ,libcairo2-dev
 ,libctemplate-dev
 ,libfreetype6-dev
 ,libgdal-dev
 ,libgl1-mesa-dev
 ,libglib2.0-dev
 ,libgnome-keyring-dev
 ,libgtkmm-2.4-dev
 ,liblua5.1-0-dev
 ,libmysqlcppconn-dev (>= 1.1.1)
 ,libpng-dev
 ,libmysqlclient-dev
 ,libpcre3-dev
 ,libpixman-1-dev
 ,libsqlite3-dev
 ,libtinyxml-dev (>= 2.6.2)
 ,libvsqlitepp-dev
 ,libxml2-dev
 ,libzip-dev
 ,python-dev
 ,unixodbc-dev
 ,uuid-dev
 ,xdg-utils
Standards-Version: 3.9.6
Homepage: http://dev.mysql.com/workbench/
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/mysql-workbench.git
Vcs-Git: git://anonscm.debian.org/collab-maint/mysql-workbench.git

Package: mysql-workbench
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends}
 ,mysql-workbench-data (= ${source:Version})
 ,python-mysql.connector
 ,python-paramiko
 ,python-pexpect
 ,python-pyodbc (>= 2.1.8)
 ,python-pysqlite2
Recommends: ttf-bitstream-vera, mysql-utilities
           ,mysql-client | virtual-mysql-client
Suggests: gnome-keyring
Description: MySQL Workbench - a visual database modeling, administration and queuing tool
 MySQL Workbench is a modeling tool that allow to design
 and generate MySQL databases graphically. It also has administration
 and query development modules where you can manage MySQL server instances
 and execute SQL queries.

Package: mysql-workbench-data
Architecture: all
Depends: ${misc:Depends}
Description: MySQL Workbench -- architecture independent data
 MySQL Workbench is a modeling tool that allow to design
 and generate MySQL databases graphically. It also has administration
 and query development modules where you can manage MySQL server instances
 and execute SQL queries.
 .
 This package provides architecture independent files

#Package: mysql-workbench-dbg
#Section: debug
#Priority: extra
#Architecture: any
#Depends: mysql-workbench (= ${binary:Version}), ${misc:Depends}
#Description: MySQL Workbench -- debugging symbols
# MySQL Workbench is a modeling tool that allow to design
# and generate MySQL databases graphically. It also has administration
# and query development modules where you can manage MySQL server instances
# and execute SQL queries.
# .
# This package provides debugging symbols

#Package: mysql-workbench-docs
#Architecture: all
#Depends: ${misc:Depends}, libjs-jquery
#Recommends: yelp
#Suggests: www-browser
#Section: doc
#Description: MySQL Workbench -- Documentation for developers
# MySQL Workbench is a modeling tool that allow to design
# and generate MySQL databases graphically. It also has administration
# and query development modules where you can manage MySQL server instances
# and execute SQL queries.
# .
# This package provides documentation for developers

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

PKD  = $(abspath $(dir $(MAKEFILE_LIST)))
PKG  = $(word 2,$(shell dpkg-parsechangelog -l$(PKD)/changelog | grep ^Source))

# parallel build by default on linux
ifeq ($(DEB_HOST_ARCH_OS),linux)
    ifeq ($(findstring parallel=,$(DEB_BUILD_OPTIONS)),)
        export DEB_BUILD_OPTIONS+=parallel=$(shell getconf _NPROCESSORS_ONLN)
    endif
endif
$(info Info: DEB_BUILD_OPTIONS:$(origin DEB_BUILD_OPTIONS)=$(DEB_BUILD_OPTIONS))

# minimise needless linking
export DEB_LDFLAGS_MAINT_APPEND= -Wl,--as-needed

%:
	dh $@ --parallel --max-parallel=4 --with python2,autoreconf

override_dh_clean:
	$(RM) -rv CMakeFiles ext/antlr-runtime/.libs
	dh_clean

override_dh_auto_configure:
	dh_auto_configure -- \
            -DUSE_UNIXODBC=ON \
            -DCMAKE_INSTALL_PREFIX=/usr \
            -DREAL_EXECUTABLE_DIR=/usr/lib/$(PKG)

override_dh_auto_build:
	# rebuild files generated by flex/bison
	cd library/sql.parser/yy_gen-tool/yy_gen-tool/ \
        && bison -dl parser.yy \
        && flex -B -oparser.lex.cc parser.lex
	# generate icon
	convert images/icons/MySQLWorkbench-32.png debian/mysql-workbench.xpm
	# generate documentation for mysql-workbench-docs package
	#cd doc && ./DoxygenRun.sh
	# build all the rest
	dh_auto_build --max-parallel=4

override_dh_auto_install:
	dh_auto_install --max-parallel=4 --destdir=$(CURDIR)/debian/tmp
	# .desktop to unix line endings
	sed -i 's/\r//g' debian/tmp/usr/share/applications/*.desktop
	# remove *.la files
	find . -name '*.la' -delete -printf 'removing %p\n'
	# install link to launcher to /usr/bin/
	dh_link -p$(PKG) \
            usr/lib/$(PKG)/mysql-workbench usr/bin/mysql-workbench

override_dh_compress:
	dh_compress --exclude=.mwb

override_dh_makeshlibs:
	dh_makeshlibs --noscripts

# help `dh_shlibdeps` to find local libraries: 'dpkg-shlibdeps: error: couldn't find library'
override_dh_shlibdeps:
	LD_LIBRARY_PATH="debian/$(PKG)/usr/lib/$(PKG):$(LD_LIBRARY_PATH)" dh_shlibdeps

# -dbg package will be over 150 MiB
override_dh_strip:
	[ -d "$(CURDIR)/debian/$(PKG)-dbg" ] \
        && dh_strip --dbg-package=$(PKG)-dbg \
        || dh_strip

override_dh_builddeb:
	dh_builddeb -- -Zxz

## semi-automated manpage generation (to invoke manually)
MAN_NAME=mysql-workbench \\- MySQL Database Design, Administration and Development Tool
mysql-workbench.1:
	help2man --no-info --manual="mysql-workbench" --name="$(MAN_NAME)" mysql-workbench > $@
	perl \
            -E 's{^.*?\s+\\-\s+mysql-workbench.*}{$(MAN_NAME)}; # correcting NAME section'     \
            -E 's{^\.SH DESCRIPTION}{.SH SYNOPSIS};             # correcting SYNOPSIS section' \
            -E 's{^mysql\\-workbench\K\\-bin}{};                # correcting executable name'  \
            -E 's{^Options:}{.SH OPTIONS};                      # create OPTIONS section'      \
            -pi $@

## http://wiki.debian.org/onlyjob/get-orig-source
UVER  = $(shell dpkg-parsechangelog -l$(PKD)/changelog | perl -ne 'print $$1 if m{^Version:\s+(?:\d+:)?(\d.*)(?:\-\d+.*)};')
DTYPE = +dfsg
VER  ?= $(subst $(DTYPE),,$(UVER))
.PHONY: get-orig-source
get-orig-source: $(PKG)_$(VER)$(DTYPE).orig.tar.xz $(info I: $(PKG)_$(VER)$(DTYPE))
	@

$(PKG)_$(VER)$(DTYPE).orig.tar.xz:
	@echo "# Downloading..."
	uscan --noconf --verbose --rename --destdir=$(CURDIR) --check-dirname-level=0 --force-download --download-version $(VER) $(PKD)
	$(if $(wildcard $(PKG)-$(VER)),$(error $(PKG)-$(VER) exist, aborting..))
	@echo "# Extracting..."
	mkdir $(PKG)-$(VER) \
        && tar -xf $(PKG)_$(VER).orig.tar.* --directory $(PKG)-$(VER) --strip-components 1 \
        || $(RM) -r $(PKG)-$(VER)
	@echo "# Cleaning-up..."
	find $(PKG)-$(VER) -type f -name '*.cmd' -delete -printf 'removed %p\n'
	find $(PKG)-$(VER) -type f -name '*.vc*' -delete -printf 'removed %p\n'
	find $(PKG)-$(VER) -depth -type d -name 'macosx' -exec $(RM) -r {} \; -printf 'removed %p\n'
	find $(PKG)-$(VER) -depth -type d -name 'windows' -exec $(RM) -r {} \; -printf 'removed %p\n'
	cd $(PKG)-$(VER) \
        && $(RM) -r -v \
             build/msi \
             build/res \
             build/zip \
             ext/Aga.Controls \
        0000-ext/antlr-runtime \
             ext/cppconn \
             ext/scintilla/.hgtags \
             ext/scintilla/cocoa \
             ext/scintilla/win32 \
             frontend/mac \
             library/base.windows \
             library/base.wr/resource.h \
             library/forms/winforms/resource.h \
             library/forms/cocoa \
             library/sql.parser/yy_purify-tool/dist/*.jar \
             library/sql.parser/update-tool/classes/*.class \
             MySQLWorkbench.xcodeproj \
             plugins/wb.doclib/res/DocLibrary/* \
             res/fonts \
	#$(RM) -v $(PKG)_$(VER).orig.tar.*
	@echo "# Packing..."
	find -L "$(PKG)-$(VER)" -xdev -type f -print | LC_ALL=C sort \
        | XZ_OPT="-7v" tar -caf "$(PKG)_$(VER)$(DTYPE).orig.tar.xz" -T- --owner=root --group=root --mode=a+rX \
        && $(RM) -r "$(PKG)-$(VER)"
